Index: issm/branches/trunk-jpl-damage/src/c/shared/Alloc/alloc.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Alloc/alloc.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Alloc/alloc.cpp	(revision 12878)
@@ -25,5 +25,5 @@
 #include "../Exceptions/exceptions.h"
 #include "../../include/include.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 void* xmalloc(int size){
@@ -31,9 +31,9 @@
 	void* memptr=NULL;
 
-	if(!size)_error_(" attempting to 0 size allocation!");
+	if(!size)_error2_("attempting to 0 size allocation!");
 
 	/* Use the c library to do the allocation: */
 	memptr=malloc(size);
-	if(!memptr) _error_("memory allocation failed!");
+	if(!memptr) _error2_("memory allocation failed!");
 
 	return memptr;
@@ -44,9 +44,9 @@
 	void* memptr=NULL;
 	
-	if(!size)_error_("attempting to 0 size allocation!");
+	if(!size)_error2_("attempting to 0 size allocation!");
 
 	/* Use the c library to do the allocation: */
 	memptr=calloc(n,size);
-	if(!memptr) _error_("memory allocation failed!");
+	if(!memptr) _error2_("memory allocation failed!");
 
 	return memptr;
@@ -84,14 +84,13 @@
 }
 
-
 void* xrealloc( void* pv, int size){
 	
 	register void* value=NULL;
 	
-	if(!size)_error_("attempting to realloc to zero");
+	if(!size)_error2_("attempting to realloc to zero");
 	value = (void*)realloc(pv,size);
 
 	if (value == NULL) {
-		_error_("virtual memory exhausted");
+		_error2_("virtual memory exhausted");
 	}
 	return value;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Alloc/xNewDelete.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Alloc/xNewDelete.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Alloc/xNewDelete.h	(revision 12878)
@@ -0,0 +1,97 @@
+/* \file xNewDelete.h
+ * \brief: header file for templated new/delete checking for non-null pointers
+ */
+
+#ifndef _XNEWDELETE_H_
+#define _XNEWDELETE_H_
+
+#include <cassert>
+
+
+// memory management of types 
+// T with non-trivial constructors require 
+// C++ style memory management
+#define USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+// but for speed on may alternatively use C memory managment
+// but can do so safely only for T that are at most 
+// plain old data structures (POD)
+#ifndef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+#include <cstdlib>
+#endif 
+
+template <class T> 
+T* xNew(unsigned int size) {
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+  T* aT_p=new T[size];
+  assert(aT_p);
+  return aT_p;
+#else
+  T* aT_p=(T*)malloc(size*sizeof(T));
+  assert(aT_p);
+  return aT_p;
+#endif  
+}
+
+template <class T> 
+T* xNewZeroInit(unsigned int size) {
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+  T* aT_p=xNew<T>(size);
+  for (unsigned int i=0; i<size;++i) 
+    aT_p[i]=(T)0;
+  return aT_p;
+#else
+  T* aT_p=(T*)calloc(size,sizeof(T));
+  assert(aT_p);
+  return aT_p;
+#endif
+}
+
+template <class T>
+void xDelete(T*& aT_p) { 
+  if (aT_p) 
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+    delete []aT_p;
+#else
+    free((void*)aT_p);
+#endif
+  aT_p=0;
+}
+
+template <class T> 
+T* xReNew(T* old, unsigned int old_size, unsigned int size) {
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+  T* aT_p=0;
+  if (!old) { // no old memory
+    if (size)  
+      aT_p=xNew<T>(size); // according to realloc behavior in manual page 
+  }
+  else { // have old memory
+    if (!size)  // but 0 size
+      xDelete<T>(old); // according to realloc behavior in manual page
+    else { // non-zero size
+      assert(old_size); // have old memory - need to have old_size set or this call is bad
+      // allocate new, delete old; ; even for the case when size is 
+      // less than old_size we can't just keep the memory unchanged 
+      // because otherwise classes that have ctors/dtors with side-effects 
+      // may misbehave, for example classes with static instance/operations counters. 
+      aT_p=xNew<T>(size);
+      unsigned int iMax=(old_size<size)?old_size:size;
+      for (unsigned int i=0; i<iMax;++i) { 
+	// we need to copy the items by explicit assignments
+	aT_p[i]=old[i];
+      }
+      xDelete<T>(old);
+    }
+  }
+  return aT_p;
+#else
+  T* aT_p=0;
+  aT_p=(T*)realloc((void*)old,size*sizeof(T));
+  if (size) 
+    assert(aT_p); // according to realloc behavior in manual page
+  return aT_p;
+#endif 
+}
+
+#endif
+
Index: issm/branches/trunk-jpl-damage/src/c/shared/Bamg/OppositeAngle.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Bamg/OppositeAngle.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Bamg/OppositeAngle.h	(revision 12878)
@@ -2,5 +2,5 @@
 #define _OPPOSITEANGLE_H_
 
-#include "../../objects/Bamg/include.h"
+#include "../../classes/bamg/include.h"
 
 /*Return the opposite angle modulo 2 Pi*/
Index: issm/branches/trunk-jpl-damage/src/c/shared/Bamg/det.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Bamg/det.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Bamg/det.h	(revision 12878)
@@ -2,5 +2,5 @@
 #define _BAMGDET_H_
 
-#include "../../objects/Bamg/include.h"
+#include "../../classes/bamg/include.h"
 
 namespace bamg {
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/Arrhenius.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/Arrhenius.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/Arrhenius.cpp	(revision 12878)
@@ -6,5 +6,5 @@
 #include <math.h>
 
-double Arrhenius(double temperature,double depth,double n){
+IssmDouble Arrhenius(IssmDouble temperature,IssmDouble depth,IssmDouble n){
 	/*Use EISMINT Parameterization for the rheology: Payne2000
 	 *
@@ -25,9 +25,9 @@
 
 	/*Some physical constants (Payne2000)*/
-	double beta=8.66*pow(10.,-4.);
-	double R=8.314;
+	IssmDouble beta=8.66*pow(10.,-4.);
+	IssmDouble R=8.314;
 
 	/*Intermediaries*/
-	double A,B,Tstar;
+	IssmDouble A,B,Tstar;
 
 	/*convert temperature to absolute temperature*/
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp	(revision 12878)
@@ -0,0 +1,38 @@
+/* file:  ComputeTemperaturePrecipitation.cpp
+   Compute the temperature and precipitation at time t from 
+   the data at present day and delta18O
+ */
+
+#include "./elements.h"
+
+void ComputeDelta18oTemperaturePrecipitation(IssmDouble Delta18oSurfacePresent, IssmDouble Delta18oSurfaceLgm, IssmDouble Delta18oSurfaceTime,
+				     IssmDouble Delta18oPresent, IssmDouble Delta18oLgm, IssmDouble Delta18oTime, 
+				     IssmDouble* PrecipitationsPresentday,
+				     IssmDouble* TemperaturesLgm, IssmDouble* TemperaturesPresentday, 
+				     IssmDouble* monthlytemperaturesout, IssmDouble* monthlyprecout){
+
+  IssmDouble monthlytemperaturestmp[12],monthlyprectmp[12];
+  IssmDouble delta18oLapseRate=-6.2*pow(10.,-3);
+  IssmDouble glacialindex; // used to vary present day temperature
+  int imonth=0;
+  // printf("Delta18oTime %f\n",Delta18oTime);
+  // printf("Delta18oPresent %f\n",Delta18oPresent);
+  // printf("Delta18oLgm %f\n",Delta18oLgm);
+
+  glacialindex = (Delta18oTime-Delta18oPresent-delta18oLapseRate*(Delta18oSurfaceTime-Delta18oSurfacePresent))
+    /(Delta18oLgm-Delta18oPresent-delta18oLapseRate*(Delta18oSurfaceLgm-Delta18oSurfacePresent));
+  // printf(" monthlytemperatureseeeeee %f\n",TemperaturesPresentday[1]);
+  // printf(" monthlypreceeeeeeee %f\n",TemperaturesLgm[1]);
+  // printf(" glacialindex %f\n",glacialindex);
+
+  for (int imonth = 0; imonth<12; imonth++){  
+    monthlytemperaturestmp[imonth] = TemperaturesPresentday[imonth];//glacialindex*TemperaturesLgm[imonth] + (1-glacialindex)*TemperaturesPresentday[imonth];
+    //monthlyprectmp[imonth] = 1.5*pow(2,((monthlytemperaturestmp[imonth]-273.15-0)/10)); //equation from rob's paper
+    monthlyprectmp[imonth] = PrecipitationsPresentday[imonth];
+
+    /*Assign output pointer*/
+    *(monthlytemperaturesout+imonth) = monthlytemperaturestmp[imonth];
+    *(monthlyprecout+imonth) = monthlyprectmp[imonth];
+  }
+  // printf(" tempera %f\n",monthlytemperaturestmp[1]);
+}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/CoordinateSystemTransform.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/CoordinateSystemTransform.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/CoordinateSystemTransform.cpp	(revision 12878)
@@ -5,12 +5,12 @@
 #include <math.h>
 
-void CoordinateSystemTransform(double** ptransform,Node** nodes,int numnodes,int* cs_array){
+void CoordinateSystemTransform(IssmDouble** ptransform,Node** nodes,int numnodes,int* cs_array){
 
 	int     i,counter;
 	int     numdofs           = 0;
-	double  norm;
-	double *transform         = NULL;
-	double *values            = NULL;
-	double  coord_system[3][3];
+	IssmDouble  norm;
+	IssmDouble *transform         = NULL;
+	IssmDouble *values            = NULL;
+	IssmDouble  coord_system[3][3];
 
 	/*Some checks in debugging mode*/
@@ -22,10 +22,10 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error_("Coordinate system %s not supported yet",EnumToStringx(cs_array[i]));
+			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
 
 	/*Allocate and initialize transform matrix*/
-	transform=(double*)xmalloc(numdofs*numdofs*sizeof(double));
+	transform=xNew<IssmDouble>(numdofs*numdofs);
 	for(i=0;i<numdofs*numdofs;i++) transform[i]=0.0;
 
@@ -67,5 +67,5 @@
 				break;
 			default:
-				_error_("Coordinate system %s not supported yet",EnumToStringx(cs_array[i]));
+				_error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetGlobalDofList.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetGlobalDofList.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetGlobalDofList.cpp	(revision 12878)
@@ -14,5 +14,5 @@
 
 		/*Allocate:*/
-		ndof_list=(int*)xmalloc(numnodes*sizeof(int));
+		ndof_list=xNew<int>(numnodes);
 
 		/*First, figure out size of doflist: */
@@ -25,5 +25,5 @@
 		if(numdof){
 			/*Allocate: */
-			doflist=(int*)xmalloc(numdof*sizeof(int));
+			doflist=xNew<int>(numdof);
 
 			/*Populate: */
@@ -37,5 +37,5 @@
 	}
 	/*Free ressources:*/
-	xfree((void**)&ndof_list);
+	xDelete<int>(ndof_list);
 
 	return doflist;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetLocalDofList.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetLocalDofList.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetLocalDofList.cpp	(revision 12878)
@@ -13,6 +13,6 @@
 	if(numnodes){
 		/*allocate: */
-		ndof_list=(int*)xmalloc(numnodes*sizeof(int));
-		ngdof_list_cumulative=(int*)xmalloc(numnodes*sizeof(int));
+		ndof_list=xNew<int>(numnodes);
+		ngdof_list_cumulative=xNew<int>(numnodes);
 
 
@@ -33,5 +33,5 @@
 		if(numdof){
 			/*Allocate: */
-			doflist=(int*)xmalloc(numdof*sizeof(int));
+			doflist=xNew<int>(numdof);
 
 			/*Populate: */
@@ -55,6 +55,6 @@
 
 	/*Free ressources:*/
-	xfree((void**)&ndof_list);
-	xfree((void**)&ngdof_list_cumulative);
+	xDelete<int>(ndof_list);
+	xDelete<int>(ngdof_list_cumulative);
 
 	/*CLean-up and return*/
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetVerticesCoordinates.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetVerticesCoordinates.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/GetVerticesCoordinates.cpp	(revision 12878)
@@ -5,5 +5,5 @@
 #include "./elements.h"
 
-void GetVerticesCoordinates(double* xyz,  Node** nodes, int numvertices){
+void GetVerticesCoordinates(IssmDouble* xyz,  Node** nodes, int numvertices){
 
 	/*In debugging mode, check that nodes is not a NULL pointer*/
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/Paterson.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/Paterson.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/Paterson.cpp	(revision 12878)
@@ -7,9 +7,11 @@
 #include <math.h>
 
-double Paterson(double temperature){
+#include "../../include/include.h"
+
+IssmDouble Paterson(IssmDouble temperature){
 	
 	/*output: */
-	double B;
-	double T;
+	IssmDouble B;
+	IssmDouble T;
 
 	/*Switch to celsius from Kelvin: */
@@ -30,39 +32,39 @@
 
 	if(T<=-45.0){
-		B=pow((double)10,(double)8)*(-0.000292866376675*pow(T+50,3)+ 0.011672640664130*pow(T+50,2)  -0.325004442485481*(T+50)+  6.524779401948101);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.000292866376675*pow(T+50,3)+ 0.011672640664130*pow(T+50,2)  -0.325004442485481*(T+50)+  6.524779401948101);
 	}
 	else if((T>=-45.0) && (T<=-40.0)){
-		B=pow((double)10,(double)8)*(-0.000292866376675*pow(T+45,3)+ 0.007279645014004*pow(T+45,2)  -0.230243014094813*(T+45)+  5.154964909039554);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.000292866376675*pow(T+45,3)+ 0.007279645014004*pow(T+45,2)  -0.230243014094813*(T+45)+  5.154964909039554);
 	}
 	else if((T>=-40.0) && (T<=-35.0)){
-		B=pow((double)10,(double)8)*(0.000072737147457*pow(T+40,3)+  0.002886649363879*pow(T+40,2)  -0.179411542205399*(T+40)+  4.149132666831214);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(0.000072737147457*pow(T+40,3)+  0.002886649363879*pow(T+40,2)  -0.179411542205399*(T+40)+  4.149132666831214);
 	}
 	else if((T>=-35.0) && (T<=-30.0)){
-		B=pow((double)10,(double)8)*(-0.000086144770023*pow(T+35,3)+ 0.003977706575736*pow(T+35,2)  -0.145089762507325*(T+35)+  3.333333333333331);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.000086144770023*pow(T+35,3)+ 0.003977706575736*pow(T+35,2)  -0.145089762507325*(T+35)+  3.333333333333331);
 	}
 	else if((T>=-30.0) && (T<=-25.0)){
-		B=pow((double)10,(double)8)*(-0.000043984685769*pow(T+30,3)+ 0.002685535025386*pow(T+30,2)  -0.111773554501713*(T+30)+  2.696559088937191);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.000043984685769*pow(T+30,3)+ 0.002685535025386*pow(T+30,2)  -0.111773554501713*(T+30)+  2.696559088937191);
 	}
 	else if((T>=-25.0) && (T<=-20.0)){
-		B=pow((double)10,(double)8)*(-0.000029799523463*pow(T+25,3)+ 0.002025764738854*pow(T+25,2)  -0.088217055680511*(T+25)+  2.199331606342181);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.000029799523463*pow(T+25,3)+ 0.002025764738854*pow(T+25,2)  -0.088217055680511*(T+25)+  2.199331606342181);
 	}
 	else if((T>=-20.0) && (T<=-15.0)){
-		B=pow((double)10,(double)8)*(0.000136920904777*pow(T+20,3)+  0.001578771886910*pow(T+20,2)  -0.070194372551690*(T+20)+  1.805165505978111);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(0.000136920904777*pow(T+20,3)+  0.001578771886910*pow(T+20,2)  -0.070194372551690*(T+20)+  1.805165505978111);
 	}
 	else if((T>=-15.0) && (T<=-10.0)){
-		B=pow((double)10,(double)8)*(-0.000899763781026*pow(T+15,3)+ 0.003632585458564*pow(T+15,2)  -0.044137585824322*(T+15)+  1.510778053489523);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.000899763781026*pow(T+15,3)+ 0.003632585458564*pow(T+15,2)  -0.044137585824322*(T+15)+  1.510778053489523);
 	}
 	else if((T>=-10.0) && (T<=-5.0)){
-		B=pow((double)10,(double)8)*(0.001676964325070*pow(T+10,3)-  0.009863871256831*pow(T+10,2)  -0.075294014815659*(T+10)+  1.268434288203714);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(0.001676964325070*pow(T+10,3)-  0.009863871256831*pow(T+10,2)  -0.075294014815659*(T+10)+  1.268434288203714);
 	}
 	else if((T>=-5.0) && (T<=-2.0)){
-		B=pow((double)10,(double)8)*(-0.003748937622487*pow(T+5,3)+0.015290593619213*pow(T+5,2)  -0.048160403003748*(T+5)+  0.854987973338348);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.003748937622487*pow(T+5,3)+0.015290593619213*pow(T+5,2)  -0.048160403003748*(T+5)+  0.854987973338348);
 	}
 	else if(T>=-2.0){
-		B=pow((double)10,(double)8)*(-0.003748937622488*pow(T+2,3)-0.018449844983174*pow(T+2,2)  -0.057638157095631*(T+2)+  0.746900791092860);
+		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.003748937622488*pow(T+2,3)-0.018449844983174*pow(T+2,2)  -0.057638157095631*(T+2)+  0.746900791092860);
 	}
 
 	/*B cannot be negative!*/
-	if(B<0) B=pow((double)10,(double)6);
+	if(B<0) B=pow((IssmPDouble)10,(IssmPDouble)6);
 
 	return B;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/PddSurfaceMassBalance.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 12878)
@@ -0,0 +1,205 @@
+/* file:  PddSurfaceMassBlance.cpp
+   Calculating the surface mass balance using the positive degree day method.
+ */
+
+#include "./elements.h"
+
+IssmDouble PddSurfaceMassBlance(IssmDouble* monthlytemperatures, IssmDouble* monthlyprec, IssmDouble* pdds, IssmDouble* pds, IssmDouble signorm, IssmDouble yts, IssmDouble h, IssmDouble s, IssmDouble rho_ice, IssmDouble rho_water){
+
+  // output:
+  IssmDouble B;    // surface mass balance, melt+accumulation
+
+  int    iqj,imonth, j;
+  
+  IssmDouble saccu;     // yearly surface accumulation
+  IssmDouble smelt;     // yearly melt
+  IssmDouble precrunoff;      // yearly runoff
+  IssmDouble prect; // total precipitation during 1 year taking into account des. ef.
+  IssmDouble water; //water=rain + snowmelt 
+  IssmDouble runoff; //meltwater only, does not include rain 
+  IssmDouble sconv; //rhow_rain/rhoi / 12 months
+  
+  IssmDouble density;
+  IssmDouble lapser=6.5/1000., sealev=0.;    // lapse rate. degrees per meter. 7.5 lev's 99 paper, 9 Marshall 99 paper
+  IssmDouble desfac = 0.5;                 // desert elevation factor
+  IssmDouble s0p=0.;         // should be set to elevation from precip source
+  IssmDouble s0t=0.;         // should be set to elevation from temperature source
+  IssmDouble st;             // elevation between altitude of the temp record and current altitude
+  IssmDouble sp;             // elevation between altitude of the prec record and current altitude
+  
+  // PDD and PD constants and variables
+  IssmDouble siglim;          // sigma limit for the integration which is equal to 2.5 sigmanorm
+  IssmDouble signormc = signorm - 0.5;     // sigma of the temperature distribution for cloudy day
+  IssmDouble siglimc, siglim0, siglim0c;
+  IssmDouble PDup, pddsig, PDCUT = 2.0; // PDcut: rain/snow cutoff temperature (C)
+  IssmDouble DT = 0.02;
+  IssmDouble pddt, pd; // pd: snow/precip fraction, precipitation falling as snow
+  
+  IssmDouble q, qmpt; // q is desert/elev. fact, hnpfac is huybrect fact, and pd is normal dist.
+  IssmDouble qm = 0.;        // snow part of the precipitation 
+  IssmDouble qmt = 0.;       // precipitation without desertification effect adjustment
+  IssmDouble qmp = 0.;       // desertification taken into account
+  IssmDouble pdd = 0.;     
+  IssmDouble frzndd = 0.;  
+  
+  IssmDouble tstar;          // monthly mean surface temp
+  IssmDouble Tsum= 0.;       // average summer (JJA) temperature
+  IssmDouble Tsurf = 0.;     // average annual temperature    
+  
+
+  IssmDouble deltm=1./12.;
+  int    ismon[12]={11,0,1,2,3,4,5,6,7,8,9,10};
+  
+  IssmDouble snwm;  // snow that could have been melted in a year.
+  IssmDouble snwmf; //  ablation factor for snow per positive degree day.
+  IssmDouble smf;   //  ablation factor for ice per pdd (Braithwaite 1995 from tarasov 2002).
+  
+  IssmDouble dfrz=1.5, CovrLm=2009./3.35e+5, dCovrLm=dfrz*CovrLm; //m*J kg^-1 C^-1 /(J kg^-1)=m/C yr
+  IssmDouble supice,supcap,diffndd;
+  IssmDouble fsupT=0.5,  fsupndd=0.5;  // Tsurf mode factors for supice
+  IssmDouble pddtj, hmx2;
+  
+  sconv=(rho_water/rho_ice)/12.; //rhow_rain/rhoi / 12 months
+
+  /*PDD constant*/
+  siglim = 2.5*signorm; 
+  siglimc = 2.5*signormc;
+  siglim0 = siglim/DT + 0.5;
+  siglim0c = siglimc/DT + 0.5;
+  PDup = siglimc+PDCUT;
+  
+  // seasonal loop
+    for (iqj = 0; iqj < 12; iqj++){
+      imonth =  ismon[iqj];
+  
+      st=(s-s0t)/1000.;
+      tstar = monthlytemperatures[imonth] - lapser *max(st,sealev);
+      Tsurf = tstar*deltm+Tsurf;        
+      
+      /*********compute PD ****************/
+      if (tstar < PDup){
+	pd = 1.;
+	if (tstar >= -siglimc){ pd = pds[int(tstar/DT + siglim0c)];}}
+      else { 
+	pd = 0.;}
+      
+      /******exp des/elev precip reduction*******/
+      sp=(s-s0p)/1000.; // deselev effect is wrt chng in topo
+      if (sp>0.0){q = exp(-desfac*sp);}
+      else {q = 1.0;}
+      
+      qmt= qmt + monthlyprec[imonth]*sconv;  //*sconv to convert in m of ice equivalent per month
+      qmpt= q*monthlyprec[imonth]*sconv;           
+      qmp= qmp + qmpt;
+      qm= qm + qmpt*pd;
+      
+      /*********compute PDD************/
+      // ndd(month)=-(tstar-pdd(month)) since ndd+pdd gives expectation of
+      // gaussian=T_m, so ndd=-(Tsurf-pdd)
+      if (iqj>5 &&  iqj<9){ Tsum=Tsum+tstar;} 
+      if (tstar >= siglim) {pdd = pdd + tstar*deltm;}
+      else if (tstar> -siglim){
+	pddsig=pdds[int(tstar/DT + siglim0)];
+	pdd = pdd + pddsig*deltm;
+	frzndd = frzndd - (tstar-pddsig)*deltm;}
+      else{frzndd = frzndd - tstar*deltm; }
+  } // end of seasonal loop 
+  
+  //******************************************************************
+    saccu = qm;
+    prect = qmp;     // total precipitation during 1 year taking into account des. ef.
+    Tsum=Tsum/3;
+    
+    /***** determine PDD factors *****/
+    if(Tsum< -1.) {
+      snwmf=2.65*0.001;   //  ablation factor for snow per positive degree day.*0.001 to go from mm to m/ppd
+      smf=17.22*0.001;    //  ablation factor for ice per pdd (Braithwaite 1995 from tarasov 2002)
+    } 
+    else if(Tsum< 10){
+      snwmf = (0.15*Tsum + 2.8)*0.001;
+      smf = (0.0067*pow((10.-Tsum),3) + 8.3)*0.001;
+    }
+    else{
+      snwmf=4.3*0.001;
+      smf=8.3*0.001;
+    }
+    snwmf=0.95*snwmf;
+    smf=0.95*smf;
+    
+    /*****  compute PDD ablation and refreezing *****/
+    pddt = pdd *365;
+    snwm = snwmf*pddt;       // snow that could have been melted in a year
+    hmx2 = min(h,dfrz);   // refreeze active layer max depth: dfrz
+    
+    if(snwm < saccu) {
+      water=prect-saccu + snwm; //water=rain + snowmelt
+      //     l 2.2= capillary factor
+      //     Should refreezing be controlled by frzndd or by mean annual Tsurf?
+      //     dCovrLm concept is of warming of active layer (thickness =d@=1-
+      //     >2m)
+      //     problem with water seepage into ice: should be sealed after
+      //     refreezing
+      //     so everything needs to be predicated on 1 year scale, except for
+      //     thermal
+      //     conductivity through ice
+      //     also, need to account that melt season has low accum, so what's
+      //     going to
+      //     hold the meltwater around for refreezing? And melt-time will have
+      //     low seasonal frzndd
+      
+      //      Superimposed ice :  Pfeffer et al. 1991, Tarasov 2002
+      
+      supice= min(hmx2*CovrLm*frzndd+2.2*(saccu-snwm), water); // superimposed ice
+      supcap=min(2.2*(saccu-snwm),water);
+      runoff=snwm - supice;  //meltwater only, does not include rain
+    }
+    else {  //all snow melted
+      supice= min(hmx2*CovrLm*frzndd, prect );
+      runoff= saccu + smf*(pddt-saccu/snwmf) - supice;
+      supcap=0;
+    }
+    //     pdd melting doesn't cool Tsurf, so ndd refreeze shouldn't warm it
+    //     except pdd melt heat source is atmosphere, while refreeze is
+    //     ground/ice stored interim
+    //     assume pdd=ndd, then melt should equal refreeze and Tsurf should=0
+    //     assume ndd=2*pdd, then all supice is refrozen, but Tsurf should be
+    //     <0
+    //     assume ndd>pdd, little melt => little supice 
+    //     bottom line: compare for Tsurf<0 : supice and no supice case,
+    //     expect Tsurf difference
+    //     except some of cooling flux comes from atmosphere//
+    //     1 dm supice should not raise Tsurf by 1/dCovrLm = 16.675C
+    //     does supice make sense when H< 0.1m? then d=thermoactive ice layer ////
+    //     < 0.1 
+    
+    //     make more sense to just use residual pdd-ndd except that pdd
+    //     residual not clear yet
+    //     frzndd should not be used up by refreezing in snow, so stick in
+    //     supcap.
+    diffndd=0;
+    if (frzndd>0) {
+      diffndd=fsupndd*min((supice-supcap)/dCovrLm ,frzndd);
+      frzndd=frzndd-diffndd;
+    }
+    if(runoff<0){
+      saccu= saccu -runoff;
+      smelt = 0;
+      precrunoff=prect-saccu;
+      //here assume pdd residual is 0, => 
+      Tsurf= max(Tsurf,-frzndd);
+    }
+    else {
+      smelt = runoff;
+      precrunoff=prect-max(0.,supice)-saccu;}
+    //here really need pdd balance, try 0.5 fudge factor?
+    //at least runoff>0 => it's fairly warm, so Tsurf is !<<0,
+    //yet from site plots, can be ice free with Tsurf=-5.5C
+    if(Tsurf<0) {
+      Tsurf= min(Tsurf+fsupT*diffndd , 0.);}
+    
+    B = -smelt+saccu;
+    B = B/yts;
+    pddtj=pddt;
+  
+  return B;
+}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/PrintArrays.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/PrintArrays.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/PrintArrays.cpp	(revision 12878)
@@ -0,0 +1,33 @@
+
+#include "./elements.h"
+#include "../../include/macros.h"
+using namespace std;
+
+void printarray(IssmPDouble* array,int lines,int cols){
+	_printLine_("");
+	for(int i=0;i<lines;i++){  
+		_printString_("   [ ");
+		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
+		_printLine_(" ]");
+	}  
+	_printLine_("");
+}
+void printarray(int* array,int lines,int cols){
+	_printLine_("");
+	for(int i=0;i<lines;i++){  
+		_printString_("   [ ");
+		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
+		_printLine_(" ]");
+	}  
+	_printLine_("");
+}
+void printbinary(int n){
+	unsigned int i=1L<<(sizeof(n)*8-1);
+	while (i>0) {
+		if (n&i)
+		 _printString_("1");
+		else
+		 _printString_("0");
+		i>>=1;
+	}
+}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformInvStiffnessMatrixCoord.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformInvStiffnessMatrixCoord.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformInvStiffnessMatrixCoord.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 
 	/*All nodes have the same Coordinate System*/
-	cs_array=(int*)xmalloc(numnodes*sizeof(int));
+	cs_array=xNew<int>(numnodes);
 	for(int i=0;i<numnodes;i++) cs_array[i]=cs_enum;
 
@@ -16,5 +16,5 @@
 
 	/*Clean-up*/
-	xfree((void**)&cs_array);
+	xDelete<int>(cs_array);
 }
 
@@ -23,6 +23,6 @@
 	int     i,j;
 	int     numdofs   = 0;
-	double *transform = NULL;
-	double *values    = NULL;
+	IssmDouble *transform = NULL;
+	IssmDouble *values    = NULL;
 
 	/*Get total number of dofs*/
@@ -31,10 +31,10 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error_("Coordinate system %s not supported yet",EnumToStringx(cs_array[i]));
+			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
 
 	/*Copy current stiffness matrix*/
-	values=(double*)xmalloc(Ke->nrows*Ke->ncols*sizeof(double));
+	values=xNew<IssmDouble>(Ke->nrows*Ke->ncols);
 	for(i=0;i<Ke->nrows;i++) for(j=0;j<Ke->ncols;j++) values[i*Ke->ncols+j]=Ke->values[i*Ke->ncols+j];
 
@@ -49,5 +49,5 @@
 
 	/*Free Matrix*/
-	xfree((void**)&transform);
-	xfree((void**)&values);
+	xDelete<IssmDouble>(transform);
+	xDelete<IssmDouble>(values);
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformLoadVectorCoord.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformLoadVectorCoord.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformLoadVectorCoord.cpp	(revision 12878)
@@ -8,5 +8,5 @@
 
 	/*All nodes have the same Coordinate System*/
-	cs_array=(int*)xmalloc(numnodes*sizeof(int));
+	cs_array=xNew<int>(numnodes);
 	for(int i=0;i<numnodes;i++) cs_array[i]=cs_enum;
 
@@ -15,5 +15,5 @@
 
 	/*Clean-up*/
-	xfree((void**)&cs_array);
+	xDelete<int>(cs_array);
 }
 
@@ -22,6 +22,6 @@
 	int     i,j;
 	int     numdofs   = 0;
-	double *transform = NULL;
-	double *values    = NULL;
+	IssmDouble *transform = NULL;
+	IssmDouble *values    = NULL;
 
 	/*Get total number of dofs*/
@@ -30,10 +30,10 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error_("Coordinate system %s not supported yet",EnumToStringx(cs_array[i]));
+			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
 
 	/*Copy current load vector*/
-	values=(double*)xmalloc(pe->nrows*sizeof(double));
+	values=xNew<IssmDouble>(pe->nrows);
 	for(i=0;i<pe->nrows;i++) values[i]=pe->values[i];
 
@@ -46,6 +46,6 @@
 				&pe->values[0],0);
 
-	/*Free Matrix*/
-	xfree((void**)&transform);
-	xfree((void**)&values);
+	/*Free Matrices*/
+	xDelete<IssmDouble>(transform);
+	xDelete<IssmDouble>(values);
 }
